<template>
  <v-container fluid grid-list-xl py-0>
    <h2 style="margin-bottom: 2rem">{{ $t('route.survey_title') }}</h2>
    <v-card class="d-block pa-1 mx-auto header-survey-list">
      <v-container>
        <v-row justify="space-between">
          <v-col cols="auto">
            <v-card-text class="header-survey-text">
              <div>{{ $t('label.survey_total_data') }}</div>
              <div>{{ $t('label.survey_list_introduction') }}</div>
            </v-card-text>
            <v-card-text>
              <v-btn
                id="addsurvey"
                class="bottom-add-survey"
                depressed
                @click="onAddSurvey()"
              >
                <v-icon left>add_circle_outline</v-icon>
                {{ $t('label.add_new_survey') }}
              </v-btn>
            </v-card-text>
          </v-col>
          <v-col cols="auto">
            <v-img
              height="120px"
              src="/static/survey-list-icon.svg"
            />
          </v-col>
        </v-row>
      </v-container>
    </v-card>
    <v-row style="margin-top: 0.5%;">
      <v-col>
        <v-select
          :items="items"
          :label="$t('label.sort_by')"
          style="max-width: 45%;"
          solo
        />
      </v-col>
      <v-col>
        <search
          :list-query.sync="listQuery"
          :handle-search="handleSearch"
        />
      </v-col>
    </v-row>
    <div v-infinite-scroll="loadMore" infinite-scroll-disabled="busy" infinite-scroll-distance="10">
      <survey-list :list="listSurvey" />
    </div>
  </v-container>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  name: 'ListSurvey',
  data() {
    return {
      busy: false,
      items: [],
      listQuery: {
        page: 1,
        limit: 10,
        search: ''
      }
    }
  },
  computed: {
    ...mapGetters('survey', [
      'listSurvey',
      'totalPage'
    ])
  },
  watch: {
    'listQuery.search': {
      handler: function(value) {
        if (value.length >= 3) {
          this.handleSearch()
        } else if (value.length === 0) {
          this.handleSearch()
        }
      },
      immediate: true
    }
  },
  mounted() {
    this.loadMore()
  },
  methods: {
    onAddSurvey() {
      this.$router.push('/survey/create')
    },
    async handleSearch() {
      await this.$store.dispatch('survey/resetListSurvey')
      this.listQuery.page = 1
      await this.$store.dispatch('survey/getListSurvey', this.listQuery)
    },
    async loadMore() {
      const response = await this.$store.dispatch('survey/getListSurvey', this.listQuery)
      if (response._metaData.nextPage < this.listQuery.page) {
        this.busy = true
      } else {
        this.listQuery.page++
      }
    }
  }
}
</script>
